import { Log } from "@dao-xyz/peerbit-log";
import { Entry } from "@dao-xyz/peerbit-log";
export const join = async (entry, into, options) => {
    // Notify the Store that we made progress
    const shouldFetch = (h) => {
        return !!h && !into.has(h);
    };
    let log;
    if (typeof entry === "string" ||
        (Array.isArray(entry) &&
            (entry.length === 0 || typeof entry[0] === "string"))) {
        log = await Log.fromEntryHash(into._storage, into._identity, entry, {
            // TODO, load all store options?
            encryption: into._encryption,
            encoding: into._encoding,
            sortFn: into._sortFn,
            length: -1,
            exclude: [],
            shouldFetch,
            concurrency: options?.concurrency,
            onFetched: options?.onFetched,
        });
    }
    else {
        let entries;
        if (Array.isArray(entry)) {
            if (entry[0] instanceof Entry) {
                entries = entry;
            }
            else {
                entries = [];
                for (const e of entry) {
                    entries.push(e.entry);
                    e.references.forEach((ref) => {
                        entries.push(ref);
                    });
                }
            }
        }
        else {
            entries = [entry];
        }
        log = await Log.fromEntry(into._storage, into._identity, entries, {
            // TODO, load all store options?
            encryption: into._encryption,
            encoding: into._encoding,
            sortFn: into._sortFn,
            length: -1,
            shouldFetch,
            concurrency: options?.concurrency,
            onFetched: options?.onFetched,
        });
    }
    return into.join(log);
};
//# sourceMappingURL=replicator.js.map